#include "guimodule.h"
#include "it_enum_list.h"
#include <math.h>

#define PN_IN 0
#define PN_OUT 1

GuiModule::GuiModule( seGuiCallback seaudioMaster, void *p_resvd1) : SEGUI_base(seaudioMaster, p_resvd1),m_fbk_preventor(false)

{
}

void GuiModule::OnGuiPinValueChange(SeGuiPin *p_pin)
{
	
	it_enum_list it( getPin(PN_OUT)->getExtraData() );
	int listlength = it.size();
	int indexin = getPin(PN_OUT)->getValueInt();
	float itemsect = 1.f / (listlength -1);
	float in_val = getPin(PN_IN)->getValueFloat();

	if (m_fbk_preventor == false && listlength > 1)
	{
		m_fbk_preventor = true;

		switch( p_pin->getIndex() )
		{
			case PN_IN:
			{
				/*
				//int indexout = floor(in_val * (listlength - 1));
				getPin(PN_OUT)->setValueInt( in_vali );
				*/
				// new code 10/01/06
				int indexout = -1;


				for (int i = 0;i < listlength;i++)
				{
					if (in_val <= i * itemsect) 
					{
						indexout = i;
						break;
					}
				}
			// end new code

				getPin(PN_OUT)->setValueInt( indexout );
			}
			break;
			case PN_OUT:
			{

					getPin(PN_IN)->setValueFloat( (float) indexin * (1.f / ((float) listlength -1)) );
			}
			break;
		}

		m_fbk_preventor = false;
	}

}





